//
//  HPRTTestPrint.m
//
//  Created by midmirror on 15/12/18.
//  Copyright © 2015年 midmirror. All rights reserved.
//

#import "HPRTTestESC.h"
#import "HPRTFunctionESC.h"
#import <HPRTSDK/HPRTSDK.h>

@interface HPRTTestESC ()

@end

@implementation HPRTTestESC


- (NSString *)getCurrentTime:(NSString *)title
{
    NSDate *nowDate = [NSDate date];
    NSDateFormatter *dateFormatter = [[NSDateFormatter alloc] init];
    [dateFormatter setDateFormat:@"yyyy/MM/dd HH:mm:ss"];
    NSString *currentTime = [dateFormatter stringFromDate:nowDate];
    NSString *timeString = [NSString stringWithFormat:@"%@:%@",title,currentTime];
 
    return timeString;
}

- (void)printText
{
    
    HPRTCommandESC *esc = [[HPRTCommandESC alloc] init];

    [esc initCMDQueue];

    [esc escSelectPrintMode:1];
    [esc escAddTextDataToCMDQueue:@"FontB: HPRTPrinter iOS Demo"];
    
    [esc escSelectPrintMode:8];
    [esc escAddTextDataToCMDQueue:@"加粗: HPRTPrinter iOS Demo"];
    
    [esc escSelectPrintMode:16];
    [esc escAddTextDataToCMDQueue:@"倍高: HPRTPrinter iOS Demo"];
    
    [esc escSelectPrintMode:32];
    [esc escAddTextDataToCMDQueue:@"倍宽: HPRTPrinter iOS Demo"];
    
    [esc escSelectPrintMode:128];
    [esc escAddTextDataToCMDQueue:@"下划线: HPRTPrinter iOS Demo"];
    
    NSData *data = [esc generateCMDData];
    [[HPRTDispatcher share] sendData:data];
}

- (void)printBarcode
{
    HPRTFunctionESC *esc = [[HPRTFunctionESC alloc] init];
    
    NSData *upceData    = [esc escPrintBarCodeWithJustification:0 Type:1 Width:2 Height:40 HRIPosition:2 Barcode:@"01227000009"];
    NSData *ean8Data    = [esc escPrintBarCodeWithJustification:0 Type:3 Width:2 Height:40 HRIPosition:2 Barcode:@"04210009"];
    NSData *ean13Data   = [esc escPrintBarCodeWithJustification:0 Type:2 Width:2 Height:40 HRIPosition:2 Barcode:@"6901028075831"];
    NSData *code93Data  = [esc escPrintBarCodeWithJustification:0 Type:72 Width:2 Height:40 HRIPosition:2 Barcode:@"TEST93"];
    NSData *code39Data  = [esc escPrintBarCodeWithJustification:0 Type:4 Width:2 Height:40 HRIPosition:2 Barcode:@"123456789"];
    NSData *codebarData = [esc escPrintBarCodeWithJustification:0 Type:6 Width:2 Height:40 HRIPosition:2 Barcode:@"A12584A"];
    NSData *itfData     = [esc escPrintBarCodeWithJustification:0 Type:5 Width:2 Height:40 HRIPosition:2 Barcode:@"123456789012"];
    NSData *code128Data = [esc escPrintBarCodeWithJustification:0 Type:73 Width:2 Height:40 HRIPosition:2 Barcode:@"A1256"];
    
    NSData *qrcodeData = [esc escPrintQRCodeWithJustification:0 LeftMargin:0 Model:50 Size:10 CorrectionLevel:48 QRCode:@"Hello World"];
    
    NSArray *codeArray = @[upceData,ean8Data,ean13Data,code93Data,code39Data,codebarData,itfData,code128Data,qrcodeData];
    [[HPRTDispatcher share] sendDataQueue:codeArray];

}

- (void)printReceipt
{
    HPRTBitmap *bitmap = [[HPRTBitmap alloc] init];
    NSData *logoData2 = [bitmap generateMonoBitmapDefault:[UIImage imageNamed:@"logo2.jpg"]];
    
    NSMutableString *companyMessage = [[NSMutableString alloc] init];
    [companyMessage appendString:@"4&5F,Gaoqi Nan Shi'er Road\n"];
    [companyMessage appendString:@"(AideAirport Industiral Park)\n"];
    [companyMessage appendString:@"Xiamen,China 361006\n\n"];
    [companyMessage appendString:@"Tel:5932525,5932252\n"];
    [companyMessage appendString:@"Website:www.prttech.com\n\n"];
    
    HPRTFunctionESC *esc = [[HPRTFunctionESC alloc] init];
    HPRTCommandESC *cmdESC = [[HPRTCommandESC alloc] init];
    NSData *companyData = [cmdESC generateTextDataWithEncoding:companyMessage];
    
    NSMutableString *receiptText = [[NSMutableString alloc] init];
    [receiptText appendString:@"------------------------------\n"];
    [receiptText appendString:@"           NO.1008            \n"];
    [receiptText appendString:[self getCurrentTime:@"Time"]];
    [receiptText appendString:@"\n"];
    [receiptText appendString:@"------------------------------\n"];
    [receiptText appendString:@"MPT-II          1      $700.00\n"];
    [receiptText appendString:@"MPT-III         1      $700.00\n"];
    [receiptText appendString:@"LPQ58           1      $800.00\n"];
    [receiptText appendString:@"TP-801          1      $800.00\n"];
    [receiptText appendString:@"TP-805          1      $900.00\n"];
    [receiptText appendString:@"POS80A          1      $900.00\n"];
    [receiptText appendString:@"POS80B          1      $950.00\n"];
    [receiptText appendString:@"POS80C          1      $950.00\n"];
    [receiptText appendString:@"SMP-R381        1      $850.00\n"];
    [receiptText appendString:@"SMP-R385        1      $850.00\n"];
    [receiptText appendString:@"SMP-R386        1      $850.00\n"];
    [receiptText appendString:@"MPT-II          1      $700.00\n"];
    [receiptText appendString:@"MPT-III         1      $700.00\n"];
    [receiptText appendString:@"LPQ58           1      $800.00\n"];
    [receiptText appendString:@"TP-801          1      $800.00\n"];
    [receiptText appendString:@"TP-805          1      $900.00\n"];
    [receiptText appendString:@"POS80A          1      $900.00\n"];
    [receiptText appendString:@"POS80B          1      $950.00\n"];
    [receiptText appendString:@"POS80C          1      $950.00\n"];
    [receiptText appendString:@"SMP-R381        1      $850.00\n"];
    [receiptText appendString:@"SMP-R385        1      $850.00\n"];
    [receiptText appendString:@"SMP-R386        1      $850.00\n"];
    [receiptText appendString:@"------------------------------\n\n"];
    [receiptText appendString:@"Total                $18500.00\n"];
    [receiptText appendString:@"-------------------------------\n\n"];
    
    NSData *textData = [cmdESC generateTextDataWithEncoding:receiptText];
    
    int barcodeType         = 0;
    int barcodeAligment     = 1;
    int barcodeNumberAround = 2;
    int barcodeWidth        = 3;
    int barcodeHeight       = 30;
    NSString *printData = @"075678164125";
    
    NSData *barcodeData = [esc escPrintBarCodeWithJustification:barcodeAligment Type:barcodeType Width:barcodeWidth Height:barcodeHeight HRIPosition:barcodeNumberAround Barcode:printData];

//    printData = @"https://itunes.apple.com/cn/app/prt_printerESC/id1080883925?mt=8";
    printData = @"www.prttech.com";

    NSData *qrcodeData = [esc escPrintQRCodeWithJustification:0 LeftMargin:0 Model:50 Size:10 CorrectionLevel:48 QRCode:printData];
    
    NSMutableString *copyright = [[NSMutableString alloc] init];
    [copyright appendString:[self getCurrentTime:@"Time"]];
    [copyright appendString:@"\n"];
    [copyright appendString:@"HPRTPrinter: V1.0.2\n"];
    [copyright appendString:@"Copyright 2016 Xiamen Hanin.\n"];
    [copyright appendFormat:@" All rights reserved\n\n\n\n"];
    NSData *copyrightData = [cmdESC generateTextDataWithEncoding:copyright];
    
    NSArray *dataQueue = @[logoData2,companyData,textData,barcodeData,qrcodeData,copyrightData];
    [[HPRTDispatcher share] sendDataQueue:dataQueue];
}

@end
