//
//  HPRTTestTSC.m
//  HPRTPrinter
//
//  Created by midmirror on 16/3/3.
//  Copyright © 2016年 HPRT. All rights reserved.
//

#import "HPRTTestTSC.h"
#import <HPRTSDK/HPRTSDK.h>

@implementation HPRTTestTSC

- (void)selfTest {
    
    HPRTCommandTSPL *tsc = [[HPRTCommandTSPL alloc] init];
    
    [tsc initCMDQueue];
    [tsc selfTest];
    [tsc sendCMDQueue];
}

- (void)printText {
    
    HPRTCommandTSPL *tsc = [[HPRTCommandTSPL alloc] init];
    
    [tsc initCMDQueue];
    
    [tsc setPrintAreaSizeWithWidth:@"100" Height:@"80"];
    [tsc setCLS];
    [tsc printTexTWithXPos:@"0" YPos:@"0" Font:@"3" Rotation:@"0" XMultiplication:@"2" YMultiplication:@"2" Text:@"Hello world"];
    [tsc printTexTWithXPos:@"20" YPos:@"20" Font:@"ROMAN.TTF" Rotation:@"0" XMultiplication:@"5" YMultiplication:@"5" Text:@"Ture Type Font Test Print"];
    [tsc printWithSets:@"1" Copies:@"1"];
    
    [tsc sendCMDQueue];
}

- (void)printBar {
    
    HPRTCommandTSPL *tsc = [[HPRTCommandTSPL alloc] init];
    
    [tsc initCMDQueue];
    
    [tsc setPrintAreaSizeWithWidth:@"1100" Height:@"30"];
    [tsc setGapWithDistance:@"0" Offset:@"0"];
    [tsc setSpeed:@"6"];
    [tsc setDensity:@"8"];
    [tsc setDirection:@"0" Mirror:@"0"];
    [tsc setCLS];
    [tsc printBarWithXPos:@"0" YPos:@"0" Width:@"1000" Height:@"20"];
    [tsc printWithSets:@"1" Copies:@"1"];
    
    [tsc sendCMDQueue];
}

- (void)printBarcode {
    
//    BARCODE 100,100,"39",96,1,0,2,4,"1000"
//    BARCODE 10,10,"128M",48,1,0,2,2,"!104!096ABCD!101EFGH"
    
    HPRTCommandTSPL *tsc = [[HPRTCommandTSPL alloc] init];
    
    NSArray *barcodeTypeArray = @[@"128",@"128M",@"EAN128",@"25",@"25C",@"39",@"39C",@"39S"];
    
    for (int i = 0; i<barcodeTypeArray.count; i++) {
        [tsc initCMDQueue];
        
        [tsc setPrintAreaSizeWithWidth:@"100" Height:@"80"];
        
        [tsc printBarcodeWithXPos:@"0" YPos:@"0" Type:barcodeTypeArray[i] Height:@"50" HumanReadable:@"0" Rotation:@"0" Narrow:@"2" Wide:@"2" CodeNumber:@"123456789"];
        
        
        [tsc printWithSets:@"1" Copies:@"1"];
        
        [tsc sendCMDQueue];
    }
    
}

- (void)printBox {
    
    HPRTCommandTSPL *tsc = [[HPRTCommandTSPL alloc] init];
    
    [tsc initCMDQueue];
    
    [tsc setPrintAreaSizeWithWidth:@"100" Height:@"100"];
    [tsc setGapWithDistance:@"0" Offset:@"0"];
    [tsc setSpeed:@"6"];
    [tsc setDirection:@"0" Mirror:@"0"];
    [tsc setCLS];
    [tsc setBoxWithXStart:@"10" YStart:@"10" XEnd:@"200" YEnd:@"90" Thickness:@"5"];
    [tsc printWithSets:@"1" Copies:@"1"];
    
    [tsc sendCMDQueue];
}

- (void)printCircle {
    
    HPRTCommandTSPL *tsc = [[HPRTCommandTSPL alloc] init];
    
    [tsc initCMDQueue];
    
    [tsc setPrintAreaSizeWithWidth:@"1100" Height:@"100"];
    [tsc setGapWithDistance:@"0" Offset:@"0"];
    [tsc setSpeed:@"6"];
    [tsc setDirection:@"0" Mirror:@"0"];
    [tsc setCLS];
    [tsc setCircleWithXStart:@"10" YStart:@"10" Diameter:@"100" Thickness:@"10"];
    [tsc printWithSets:@"1" Copies:@"1"];
    
    [tsc sendCMDQueue];
}

- (void)printDMatix {
    
    HPRTCommandTSPL *tsc = [[HPRTCommandTSPL alloc] init];
    
    [tsc initCMDQueue];
    
    [tsc setPrintAreaSizeWithWidth:@"1000" Height:@"150"];
    [tsc setGapWithDistance:@"0" Offset:@"0"];
    [tsc setSpeed:@"4"];
//    [tsc setDensity:@"8"];
    [tsc setDirection:@"0" Mirror:@"0"];
//    [tsc setReferenceXPos:@"0" YPos:@"0"];
//    [tsc setOffsetWithDistance:@"0.00"];
    //set cutter off
    [tsc setTearON];
    [tsc setCLS];
    [tsc setDmatrixWithExpression:@"DMATRIX 1" XPos:@"10" YPos:@"10" Width:@"100" Height:@"100" XM:nil Row:nil Col:nil];
    [tsc printWithSets:@"1" Copies:@"1"];
    
    [tsc sendCMDQueue];
}

- (void)printErase {
    
    HPRTCommandTSPL *tsc = [[HPRTCommandTSPL alloc] init];
    
    [tsc initCMDQueue];
    
    [tsc setPrintAreaSizeWithWidth:@"1000" Height:@"100"];
    [tsc setGapWithDistance:@"0" Offset:@"0"];
    [tsc setSpeed:@"6"];
    [tsc setDensity:@"8"];
    [tsc setDirection:@"0" Mirror:@"0"];
    [tsc setCLS];
    [tsc printBarWithXPos:@"100" YPos:@"100" Width:@"300" Height:@"300"];
    [tsc setEraseWithXStart:@"150" YStart:@"150" XWidth:@"200" YHeight:@"200"];
    [tsc printWithSets:@"1" Copies:@"1"];
    
    [tsc sendCMDQueue];
}

- (void)printMaxicode {
    
    HPRTCommandTSPL *tsc = [[HPRTCommandTSPL alloc] init];
    
    [tsc initCMDQueue];
    
    [tsc setPrintAreaSizeWithWidth:@"1000" Height:@"100"];
    [tsc setGapWithDistance:@"0" Offset:@"0"];
    [tsc setCLS];
    [tsc setSpeed:@"4"];
    [tsc setDensity:@"8"];
    [tsc setOffsetWithDistance:@"0.00"];
    [tsc setCutterOFF];
    [tsc setTearON];
    
    [tsc setMaxicode:@"MaxiCode" XPos:@"10" YPos:@"10" Mode:@"2" Class:@"300" Country:@"840" Post:@"06810" LM:@"7317"];
//    [tsc printText:@"MaxiCode" X:@"20" Y:@"20" Font:@"3" Rotation:@"0" XMultiplication:@"2" YMultiplication:@"2"];
    [tsc printWithSets:@"1" Copies:@"1"];
    
    [tsc setCLS];
    [tsc setMaxicode:@"MaxiCode 2" XPos:@"10" YPos:@"10" Mode:@"4" Class:@"300" Country:@"863" Post:@"107317" LM:@"107317"];
//    [tsc printText:@"Demo 3 for Canada Maxicode" X:@"30" Y:@"30" Font:@"3" Rotation:@"0" XMultiplication:@"2" YMultiplication:@"2"];
    
    
    [tsc printWithSets:@"1" Copies:@"1"];
    
    [tsc sendCMDQueue];
}

- (void)printPDF417 {
    
    HPRTCommandTSPL *tsc = [[HPRTCommandTSPL alloc] init];
    
    [tsc initCMDQueue];
    
    [tsc setPrintAreaSizeWithWidth:@"1000" Height:@"100"];
    [tsc setGapWithDistance:@"0" Offset:@"0"];
    [tsc setCLS];
    [tsc setSpeed:@"6"];
    [tsc setDensity:@"8"];
    [tsc setDirection:@"1" Mirror:@"0"];
    [tsc setReferenceXPos:@"0" YPos:@"0"];
    
    [tsc setCLS];
    [tsc printPDF417WithXPos:@"10" YPos:@"10" Width:@"200" Height:@"200" Rotate:@"0" Option:nil Expression:@"Without Options"];
    [tsc printWithSets:@"1" Copies:@"1"];
    
    [tsc setCLS];
    [tsc printPDF417WithXPos:@"10" YPos:@"10" Width:@"200" Height:@"200" Rotate:@"0" Option:@"E4" Expression:@"Error correction level:4"];
    [tsc printWithSets:@"1" Copies:@"1"];
    
    [tsc setCLS];
    [tsc printPDF417WithXPos:@"10" YPos:@"10" Width:@"200" Height:@"200" Rotate:@"0" Option:@"E4,W4" Expression:@"Error correction level:4 module width 4 dots"];
    [tsc printWithSets:@"1" Copies:@"1"];
    
    [tsc setCLS];
    [tsc printPDF417WithXPos:@"10" YPos:@"10" Width:@"200" Height:@"200" Rotate:@"0" Option:@"E4,W4,H4,R25" Expression:@"Error correction level:4 Module Width 4 dots"];
    [tsc printWithSets:@"1" Copies:@"1"];
    
    [tsc setCLS];
    [tsc printPDF417WithXPos:@"10" YPos:@"10" Width:@"200" Height:@"200" Rotate:@"0" Option:@"E4,W4,H4,R40,C3" Expression:@"Error correction level:4 Module Width 4 dots"];
    [tsc printWithSets:@"1" Copies:@"1"];
    
    [tsc sendCMDQueue];
}

- (void)printReceipt {
    
    HPRTCommandTSPL *tsc = [[HPRTCommandTSPL alloc] init];
    
    [tsc initCMDQueue];
    
    [tsc setPrintAreaSizeWithWidth:@"100" Height:@"80"];
    [tsc setCLS];
    [tsc printTexTWithXPos:@"0" YPos:@"0" Font:@"0" Rotation:@"0" XMultiplication:@"1" YMultiplication:@"1"
                      Text:@"厦门汉印电子科技技术有限公司"];
    
    [tsc printTexTWithXPos:@"0" YPos:@"30" Font:@"0" Rotation:@"0" XMultiplication:@"1" YMultiplication:@"1"
                      Text:@"日期：2016-08-20"];
    
    [tsc printTexTWithXPos:@"0" YPos:@"60" Font:@"0" Rotation:@"0" XMultiplication:@"1" YMultiplication:@"1"
                      Text:@"客户：厦门普瑞特"];
    
    [tsc printTexTWithXPos:@"0" YPos:@"90" Font:@"0" Rotation:@"0" XMultiplication:@"1" YMultiplication:@"1"
                      Text:@"仓库：二楼A仓库"];
    
    [tsc printTexTWithXPos:@"0" YPos:@"120" Font:@"0" Rotation:@"0" XMultiplication:@"1" YMultiplication:@"1"
                      Text:@"经手人：小张"];
    
    [tsc printTexTWithXPos:@"0" YPos:@"150" Font:@"0" Rotation:@"0" XMultiplication:@"1" YMultiplication:@"1"
                      Text:@"----------------------"];
    
    [tsc printTexTWithXPos:@"0" YPos:@"180" Font:@"0" Rotation:@"0" XMultiplication:@"1" YMultiplication:@"1"
                      Text:@"MPT-II         777.00"];
    
    [tsc printTexTWithXPos:@"0" YPos:@"210" Font:@"0" Rotation:@"0" XMultiplication:@"1" YMultiplication:@"1"
                      Text:@"MPT-III        888.00"];
    
    
    [tsc printWithSets:@"1" Copies:@"1"];
    
    [tsc sendCMDQueue];
}

- (void)printQRCode {
    
    HPRTCommandTSPL *tsc = [[HPRTCommandTSPL alloc] init];
    
    [tsc initCMDQueue];
    
    [tsc setPrintAreaSizeWithWidth:@"100" Height:@"80"];
    [tsc setCLS];
    [tsc printQRcodeWithXPos:@"0" YPos:@"0" EccLevel:@"L" CellWidth:@"15" Mode:@"M" Rotation:@"0" Model:@"M1" Mask:@"S1" Text:@"Hello world"];
    [tsc printWithSets:@"1" Copies:@"1"];
    
    [tsc sendCMDQueue];
}

- (void)printBitmap {
    
    UIImage *image = [UIImage imageNamed:@"emeya.jpg"];
    
    HPRTCommandTSPL *tsc = [[HPRTCommandTSPL alloc] init];
    HPRTBitmap *bmp = [[HPRTBitmap alloc] init];
    NSData *bmpData = [bmp generateDitherBitmapDefault:image];
    
    int remainder = (int)image.size.width%8;
    int width = (int)image.size.width/8;
    
    width = ( (remainder==0) ? width : (width +1)); //依据是否能够除尽，修正宽度
    
    int height = image.size.height;
    
    NSString *widthStr = [NSString stringWithFormat:@"%d",width];
    NSString *heightStr = [NSString stringWithFormat:@"%d",height];
    
    [tsc initCMDQueue];
    
    [tsc setPrintAreaSizeWithWidth:@"100" Height:@"80"];
    [tsc setCLS];
    [tsc printBitmapWithXPos:@"0" YPos:@"0" Width:widthStr Height:heightStr Mode:@"1"];
    [tsc addBitmapDataToCMDQueue:bmpData];
    [tsc printWithSets:@"1" Copies:@"1"];
    
    [tsc sendCMDQueue];
}

- (void)printLabel {
    
    HPRTCommandTSPL *tsc = [[HPRTCommandTSPL alloc] init];
    
    [tsc initCMDQueue];
    [tsc setPrintAreaSizeWithWidth:@"80" Height:@"150"];
    [tsc setDirection:@"0" Mirror:@"0"];
    [tsc setReferenceXPos:@"0" YPos:@"0"];
    [tsc setPeelOFF];
    [tsc setTearON];
    [tsc setCLS];
    
    [tsc printBarcodeWithXPos:@"300" YPos:@"30" Type:@"128" Height:@"64" HumanReadable:@"1" Rotation:@"0" Narrow:@"3" Wide:@"7" CodeNumber:@"363604310467"];
    [tsc printBarWithXPos:@"16" YPos:@"144" Width:@"600" Height:@"3"];
    [tsc printTexTWithXPos:@"32" YPos:@"160" Font:@"0" Rotation:@"1" XMultiplication:@"1" YMultiplication:@"1" Text:@"收件："];
    [tsc printTexTWithXPos:@"110" YPos:@"156" Font:@"1" Rotation:@"1" XMultiplication:@"2" YMultiplication:@"2" Text:@"上海市长宁区北翟路1178号（鑫达商"];
    [tsc printTexTWithXPos:@"110" YPos:@"196" Font:@"1" Rotation:@"1" XMultiplication:@"2" YMultiplication:@"2" Text:@"务楼）1号楼305室"];
    [tsc printTexTWithXPos:@"110" YPos:@"236" Font:@"1" Rotation:@"1" XMultiplication:@"2" YMultiplication:@"2" Text:@"快小宝 13826514987"];
    [tsc printBarWithXPos:@"32" YPos:@"280" Width:@"560" Height:@"3"];
    [tsc printTexTWithXPos:@"32" YPos:@"300" Font:@"0" Rotation:@"1" XMultiplication:@"1" YMultiplication:@"1" Text:@"发件："];
    [tsc printTexTWithXPos:@"110" YPos:@"300" Font:@"0" Rotation:@"1" XMultiplication:@"1" YMultiplication:@"1" Text:@"上海市宝山区共和新4719弄共和小区13号"];
    [tsc printTexTWithXPos:@"110" YPos:@"340" Font:@"0" Rotation:@"1" XMultiplication:@"1" YMultiplication:@"1" Text:@"306室"];
    [tsc printTexTWithXPos:@"110" YPos:@"380" Font:@"0" Rotation:@"1" XMultiplication:@"1" YMultiplication:@"1" Text:@"沈一峰 13965421578"];
    
    [tsc printBarWithXPos:@"16" YPos:@"420" Width:@"600" Height:@"3"];
    
    [tsc printTexTWithXPos:@"60" YPos:@"440" Font:@"0" Rotation:@"1" XMultiplication:@"2" YMultiplication:@"3" Text:@"上海 上海市 长宁区"];
    [tsc printBarWithXPos:@"16" YPos:@"530" Width:@"600" Height:@"3"];
    
    [tsc printTexTWithXPos:@"32" YPos:@"550" Font:@"0" Rotation:@"1" XMultiplication:@"1" YMultiplication:@"1" Text:@"物品："];
    [tsc printTexTWithXPos:@"110" YPos:@"550" Font:@"0" Rotation:@"1" XMultiplication:@"1" YMultiplication:@"1" Text:@"办公室迷你风"];
    
    [tsc printTexTWithXPos:@"110" YPos:@"590" Font:@"0" Rotation:@"1" XMultiplication:@"1" YMultiplication:@"1" Text:@"扇"];
    [tsc printTexTWithXPos:@"32" YPos:@"630" Font:@"0" Rotation:@"1" XMultiplication:@"1" YMultiplication:@"1" Text:@"日期：2015-07-05"];
    [tsc printBarWithXPos:@"360" YPos:@"530" Width:@"2" Height:@"150"];
    [tsc printTexTWithXPos:@"376" YPos:@"550" Font:@"0" Rotation:@"1" XMultiplication:@"1" YMultiplication:@"1" Text:@"签字："];
    [tsc printTexTWithXPos:@"440" YPos:@"630" Font:@"0" Rotation:@"1" XMultiplication:@"1" YMultiplication:@"1" Text:@"年    月    日"];
    [tsc printTexTWithXPos:@"32" YPos:@"700" Font:@"0" Rotation:@"1" XMultiplication:@"1" YMultiplication:@"1" Text:@"收件："];

    //
    [tsc printTexTWithXPos:@"110" YPos:@"692" Font:@"1" Rotation:@"1" XMultiplication:@"2" YMultiplication:@"2" Text:@"上海市长宁区北翟路1178号（鑫达商"];
    [tsc printTexTWithXPos:@"110" YPos:@"732" Font:@"1050629" Rotation:@"1" XMultiplication:@"2" YMultiplication:@"2" Text:@"务楼）1号楼305室"];
    [tsc printTexTWithXPos:@"110" YPos:@"772" Font:@"1" Rotation:@"1" XMultiplication:@"2" YMultiplication:@"2" Text:@"快小宝 13826514987"];
    [tsc printBarWithXPos:@"32" YPos:@"820" Width:@"560" Height:@"3"];
    [tsc printTexTWithXPos:@"32" YPos:@"834" Font:@"0" Rotation:@"1" XMultiplication:@"1" YMultiplication:@"1" Text:@"发件："];
    [tsc printTexTWithXPos:@"110" YPos:@"830" Font:@"0" Rotation:@"1" XMultiplication:@"1" YMultiplication:@"1" Text:@"上海市宝山区共和新4719弄共和小区13号"];
    [tsc printTexTWithXPos:@"110" YPos:@"870" Font:@"0" Rotation:@"1" XMultiplication:@"1" YMultiplication:@"1" Text:@"306室"];
    [tsc printTexTWithXPos:@"110" YPos:@"910" Font:@"0" Rotation:@"1" XMultiplication:@"1" YMultiplication:@"1" Text:@"沈一峰 13965421578"];
    
    [tsc printBarWithXPos:@"16" YPos:@"950" Width:@"600" Height:@"3"];

    [tsc printTexTWithXPos:@"32" YPos:@"970" Font:@"0" Rotation:@"1" XMultiplication:@"1" YMultiplication:@"1" Text:@"物品："];
    [tsc printTexTWithXPos:@"110" YPos:@"970" Font:@"0" Rotation:@"1" XMultiplication:@"1" YMultiplication:@"1" Text:@"办公室迷你风扇"];
    
    [tsc printTexTWithXPos:@"32" YPos:@"1010" Font:@"0" Rotation:@"1" XMultiplication:@"1" YMultiplication:@"1" Text:@"日期：2015-07-05"];
    [tsc printBarWithXPos:@"16" YPos:@"1050" Width:@"600" Height:@"3"];
    [tsc printBarcodeWithXPos:@"72" YPos:@"1066" Type:@"128" Height:@"80" HumanReadable:@"1" Rotation:@"0" Narrow:@"5" Wide:@"9" CodeNumber:@"363604310467"];
    
    [tsc printWithSets:@"1" Copies:@"1"];
    [tsc sendCMDQueue];
}
@end
