//
//  HPRTBitmapVC.m
//
//  Created by midmirror on 15/12/28.
//  Copyright © 2015年 midmirror. All rights reserved.
//

#import "HPRTBitmapVC.h"
#import "Masonry.h"

@interface HPRTBitmapVC ()

@property(strong,nonatomic,readwrite) MIDPopView *popView;
@property(strong,nonatomic,readwrite) UITableView *tableView;
@property(strong,nonatomic,readwrite) UIImage *photo;
@property(strong,nonatomic,readwrite) UIImage *bitmapSelected;
@property(strong,nonatomic,readwrite) NSArray *bitmapArray;
@property(strong,nonatomic,readwrite) MIDFlatView *flatView;
@property(strong,nonatomic,readwrite) NSIndexPath *indexPathSelected;

@end

@implementation HPRTBitmapVC

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    
    UILabel *titleLabel = [[UILabel alloc] initWithFrame:CGRectMake(0, 0 , 200, 44)];
    titleLabel.backgroundColor = [UIColor clearColor];
    titleLabel.font = [UIFont systemFontOfSize:20];
    titleLabel.textColor = [UIColor whiteColor];//设置文本颜色
    titleLabel.textAlignment = NSTextAlignmentCenter;
    titleLabel.text = @"Photo Print";
    self.navigationItem.titleView = titleLabel;
    
    _bitmapArray = @[@"logo.jpg",@"pander.jpg",@"emeya.jpg"];
    [self setupFlatView];
    [self setupFootTable];
}

- (void)setupFlatView {
    
    UIColor *headColor = PRTCOLOR_BLUE;
    UIColor *footColor = PRTCOLOR_COULD;
    
    _flatView = [[MIDFlatView alloc] initWithWidth:SCREEN_WIDTH Height:SCREEN_HEIGHT splitPercentage:0.3 headColor:headColor footColor:footColor];
    [self.view addSubview:_flatView];
    
    _flatView.mainButton.hidden = NO;
    [_flatView.mainButton setTitle:@"Send To Print" forState:UIControlStateNormal];
    [_flatView.mainButton addTarget:self action:@selector(printAction) forControlEvents:UIControlEventTouchUpInside];
}

- (void)setupFootTable {
    
    _tableView = [[UITableView alloc] initWithFrame:self.view.bounds style:UITableViewStyleGrouped];
    _tableView.dataSource = self;
    _tableView.delegate = self;
    [_flatView.footView addSubview:_tableView];
    
//    UIScrollView *scrollView = [[UIScrollView alloc] initWithFrame:self.view.bounds];
//    scrollView.scrollEnabled = YES;
//    scrollView.contentSize = CGSizeMake(_flatView.footView.bounds.size.width, _flatView.footView.bounds.size.height * 2);
//    [_flatView.footView addSubview:scrollView];
//    [scrollView addSubview:_tableView];
}

//- (void)popSuccessView {
//    
//    UIColor *headColor = PRTCOLOR_GRAY;
//    _popView = [[MIDPopView alloc] initWithWidth:SCREEN_WIDTH*0.6 Height:SCREEN_HEIGHT*0.3 splitPercentage:0.3 headColor:headColor buttonColor:nil];
//    _popView.titleLabel.text = @"Send Success";
//    _popView.footView.backgroundColor = PRTCOLOR_COULD;
//    
//    UILabel *label = [[UILabel alloc] initWithFrame:CGRectMake(0, 0, SCREEN_WIDTH*0.6, SCREEN_HEIGHT*0.15)];
//    label.text = @"Data send success";
//    label.textColor = [UIColor grayColor];
//    label.textAlignment = NSTextAlignmentCenter;
//    label.backgroundColor = PRTCOLOR_COULD;
//    [_popView.footView addSubview:label];
//    
//    __block MIDPopView *popView = _popView;
//    [_popView addButtonWithTitle:@"OK" handler:^(MIDPopViewButton *button) {
//        
//        [popView hideAnimation];
//    }];
//    
//    [_popView show];
//}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (void)printAction {
    
    switch ([HPRTDispatcher share].currentInstructionMode) {
        case InstructionModeESC_POS:    [self printEscPosBitmap];       break;
        case InstructionModeTSC_TSPL:   [self printTscTsplBitmap];      break;
            
        default:
            break;
    }
}

//ESC 指令集打印图片
- (void)printEscPosBitmap {
    
    UIImageView *resultImageView = [[UIImageView alloc] initWithFrame:CGRectMake(30, 500, 500, 375)];
    [self.view addSubview:resultImageView];
    
    HPRTBitmap *bitmap = [[HPRTBitmap alloc] init];
    NSData *printData = [bitmap generateDitherBitmapDefault:_bitmapSelected];
    [[HPRTDispatcher share] sendData:printData];
}

//TSC 指令集打印图片
- (void)printTscTsplBitmap {
    
    UIImageView *resultImageView = [[UIImageView alloc] initWithFrame:CGRectMake(30, 500, 500, 375)];
    [self.view addSubview:resultImageView];

    HPRTCommandTSPL *tsc = [[HPRTCommandTSPL alloc] init];
    HPRTBitmap *bmp = [[HPRTBitmap alloc] init];
    NSData *bmpData = [bmp generateDitherBitmapDefault:_bitmapSelected];
    
    int remainder = (int)_bitmapSelected.size.width%8;
    int width = (int)_bitmapSelected.size.width/8;
    
    width = ( (remainder==0) ? width : (width +1)); //依据是否能够除尽，修正宽度
    
    int height = _bitmapSelected.size.height;
    
    NSString *widthStr = [NSString stringWithFormat:@"%d",width];
    NSString *heightStr = [NSString stringWithFormat:@"%d",height];
    
    [tsc initCMDQueue];
    
    [tsc setPrintAreaSizeWithWidth:@"100" Height:@"80"];
    [tsc setCLS];
    [tsc printBitmapWithXPos:@"0" YPos:@"0" Width:widthStr Height:heightStr Mode:@"1"];
    [tsc addBitmapDataToCMDQueue:bmpData];
    [tsc printWithSets:@"1" Copies:@"1"];
    
    [tsc sendCMDQueue];
}



- (void)openAlbum {
    UIImagePickerController *imagePickerCtr = [[UIImagePickerController alloc] init];
    
    imagePickerCtr.sourceType = UIImagePickerControllerSourceTypePhotoLibrary;
    imagePickerCtr.delegate = self;
    imagePickerCtr.allowsEditing = YES;
    [self presentViewController:imagePickerCtr animated:YES completion:^{
        
    }];
}


- (void)openCamera {
    
    UIImagePickerController *imagePickerCtr = [[UIImagePickerController alloc] init];
    //    UIImagePickerControllerSourceTypePhotoLibrary,
    //    UIImagePickerControllerSourceTypeCamera,
    //    UIImagePickerControllerSourceTypeSavedPhotosAlbum
    
    //    UIImagePickerControllerCameraDeviceRear,
    //    UIImagePickerControllerCameraDeviceFront
    
    BOOL isCamera = [UIImagePickerController isCameraDeviceAvailable:UIImagePickerControllerCameraDeviceRear];
    if (!isCamera) {
        NSLog(@"不支持摄像头");
        return;
    }
    imagePickerCtr.sourceType = UIImagePickerControllerSourceTypeCamera;
    imagePickerCtr.delegate = self;
    imagePickerCtr.allowsEditing = YES;
    [self presentViewController:imagePickerCtr animated:YES completion:^{
        
    }];
}

#pragma mark UIImagePickerControllerDelegate
- (void)imagePickerController:(UIImagePickerController *)picker didFinishPickingMediaWithInfo:(NSDictionary *)info;
{
    NSLog(@"info = %@",info);
    
    //    UIImagePickerControllerEditedImage 编辑图片
    //    UIImagePickerControllerOriginalImage 原始图片
    
    _photo = [info objectForKey:UIImagePickerControllerEditedImage];
    [_tableView reloadData];
    
    [self dismissViewControllerAnimated:YES completion:^{
        
    }];
}
- (void)imagePickerControllerDidCancel:(UIImagePickerController *)picker;
{
    [self dismissViewControllerAnimated:YES completion:^{
        
    }];
}

- (void)viewWillAppear:(BOOL)animated {
    
    self.navigationController.navigationBar.barTintColor = PRTCOLOR_BLUE;
    self.navigationController.navigationBar.alpha = 1.0;
    [self.navigationController.navigationBar setTranslucent:NO];
}

#pragma mark UITableViewDataSource
- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView;              // Default is 1 if not implemented
{
    if (_photo) {
        return 3;
    }else {
        return 2;
    }
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section;
{
    switch (section) {
        case 0: return 2;   break;
        case 1: return 3;   break;
        case 2: return 1;   break;
        default:return 1;   break;
    }
}

- (nullable NSString *)tableView:(UITableView *)tableView titleForHeaderInSection:(NSInteger)section {

    switch (section) {
        case 0: return @"Func";     break;
        case 1: return @"Bitmap";   break;
        case 2: return @"Photo";    break;
        default:return @"unknown";  break;
    }
}

- (CGFloat)tableView:(UITableView *)tableView heightForHeaderInSection:(NSInteger)section {

    return [[MIDScreenFit share] getRowHeight]*0.7;
}

- (CGFloat)tableView:(UITableView *)tableView heightForFooterInSection:(NSInteger)section {

    return 1;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath;
{
    static NSString *iden = @"HPRTBitmapCell";
    MIDTableCell *tableCell = [tableView dequeueReusableCellWithIdentifier:iden];
    if (tableCell == nil) {
        tableCell = [[MIDTableCell alloc] initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:iden];
    }
    
    if (indexPath.section == 0) {
        
        NSArray *funcArray = @[@"Open Album",@"Open Camera"];
        NSArray *detailArray = @[@"select a photo from iOS system album",@"take a photo with camera"];
        tableCell.textLabel.text =funcArray[indexPath.row];
        tableCell.detailTextLabel.text = detailArray[indexPath.row];
        
    }else if (indexPath.section == 1){
        
        tableCell.imageView.image = [UIImage imageNamed:_bitmapArray[indexPath.row]];
        tableCell.textLabel.text = _bitmapArray[indexPath.row];
        
    }else {
        
        tableCell.imageView.image = _photo;
        tableCell.textLabel.text = @"Photo";
    }
    
    tableCell.detailTextLabel.textColor = [UIColor grayColor];
    return tableCell;
}


#pragma mark UITableViewDelegate

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath {
    return [[MIDScreenFit share] getRowHeight];
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath;
{
    if (indexPath.section == 0) {
        
        switch (indexPath.row) {
            case 0: [self openAlbum];       break;
            case 1: [self openCamera];      break;
            case 2: [self printAction];     break;
                
            default:                        break;
        }
    }else {
        if (indexPath.section == 1) {
            _bitmapSelected = [UIImage imageNamed:_bitmapArray[indexPath.row]];
        }else {
            _bitmapSelected = _photo;
        }
        UITableViewCell *lastCell = [tableView cellForRowAtIndexPath:_indexPathSelected];
        lastCell.accessoryType = UITableViewCellAccessoryNone;
        
        //    新选中的一行，通过 indexPath 找到 cell
        UITableViewCell *cell = [tableView cellForRowAtIndexPath:indexPath];
        cell.accessoryType = UITableViewCellAccessoryCheckmark;
        _indexPathSelected = indexPath;
        
        
        [tableView reloadData];
    }
}
@end
