//
//  HPRTPageVC.m
//
//  Created by midmirror on 15/12/28.
//  Copyright © 2015年 midmirror. All rights reserved.
//

#import "HPRTPageVC.h"
#import "HPRTFunctionESC.h"
#import "Masonry.h"

@interface HPRTPageVC ()

@property(strong,nonatomic,readwrite) NSDictionary *tableRowDic;
@end

@implementation HPRTPageVC

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    
    UILabel *titleLabel = [[UILabel alloc] initWithFrame:CGRectMake(0, 0 , 200, 44)];
    titleLabel.backgroundColor = [UIColor clearColor];
    titleLabel.font = [UIFont systemFontOfSize:20];
    titleLabel.textColor = [UIColor whiteColor];//设置文本颜色
    titleLabel.textAlignment = NSTextAlignmentCenter;
    titleLabel.text = @"Page Print";
    self.navigationItem.titleView = titleLabel;
    
    [self setupDataSource];
    [self setupFlatUI];
    [self setupFootTable];

    _tableKit = [MIDTableKit share];
    
}

- (void)notificationUserSelectCell:(NSNotification *)sender {
    
    _tableRowDic = [sender userInfo];
    [self popPickerViewAt:[[_tableRowDic objectForKey:@"row"] intValue]];
}

- (void)setupFlatUI {
    
    UIColor *headColor = PRTCOLOR_BLUE;
    UIColor *footColor = PRTCOLOR_COULD;
    _flatView = [[MIDFlatView alloc] initWithWidth:SCREEN_WIDTH Height:SCREEN_HEIGHT splitPercentage:0.4 headColor:headColor footColor:footColor];
    [self.view addSubview:_flatView];
    
    [_flatView.textView setText:@"Xiamen Hanin Electronic Technology Co., Ltd."];
    
    [_flatView.textView mas_makeConstraints:^(MASConstraintMaker *make) {
        
        make.centerX.equalTo(self.view.mas_centerX);
        make.top.equalTo(self.view.mas_top).offset(SCREEN_HEIGHT*0.03);
        make.size.mas_equalTo(CGSizeMake(SCREEN_WIDTH * 0.8, SCREEN_WIDTH * 0.15));
    }];
    
    _flatView.mainButton.hidden = NO;
    [_flatView.mainButton setTitle:@"Send To Print" forState:UIControlStateNormal];
    [_flatView.mainButton addTarget:self action:@selector(sendToPrinterAction) forControlEvents:UIControlEventTouchUpInside];
    
    MIDScreenFit *fit = [[MIDScreenFit alloc] init];
    CGFloat buttonWidth = [fit getMainButtonWidth];
    CGFloat buttonHeight = [fit getMainButtonHeight];
    
    [_flatView.mainButton mas_makeConstraints:^(MASConstraintMaker *make) {
        
        make.centerX.equalTo(self.view);
        make.bottom.equalTo(_flatView.headView.mas_bottom).offset(-SCREEN_HEIGHT*0.03);
        make.size.mas_equalTo(CGSizeMake(buttonWidth, buttonHeight));
    }];
}

- (void)updateTitleAndParameter:(NSNumber *)row {
    
    if (row) {
        
        int rowInt = [row intValue];
        MIDToolBox *tool = [[MIDToolBox alloc] init];
        NSString *newDetailTitle = [tool pieceStringWithArray:[MIDPickerKitModel share].titleArray];
        
        if ((rowInt !=6 )) {
            
            newDetailTitle = [NSString stringWithFormat:@"%d",[newDetailTitle intValue]];
           [_parameterArray replaceObjectAtIndex:rowInt withObject:newDetailTitle];
        }else {
            
            NSString *pickerRow = [[MIDPickerKitModel share].rowArray[0] stringValue];
            [_parameterArray replaceObjectAtIndex:rowInt withObject:pickerRow];
        }
        [_detailTextArray replaceObjectAtIndex:[row integerValue] withObject:newDetailTitle];
    }
}

- (void)setupFootTable {
    
    NSArray *titleArray = @[@"LeftMargin(0≤n≤383)",@"TopMargin(0≤n≤935)",@"Width(0≤n≤384)",@"Height(0≤n≤936)",@"X coordinate",@"Y coordinate",@"Direction"];
    
    NSArray *tableDataArray = @[titleArray,_detailTextArray];
    
    _tableKit = [[MIDTableKit alloc] initWithWidth:SCREEN_WIDTH Height:SCREEN_HEIGHT*0.6 DataArray:tableDataArray TableMode:MIDTableModeNormal CheckMark:NO];
    
    [_flatView.footView addSubview:_tableKit];
}

- (void)popPickerViewAt:(int)row {
    
    UIColor *headColor = PRTCOLOR_GRAY;
    UIColor *buttonColor = PRTCOLOR_GRAY;
    
    _popView = [[MIDPopView alloc] initWithWidth:SCREEN_WIDTH*0.6 Height:SCREEN_HEIGHT*0.4 splitPercentage:0.2 headColor:headColor buttonColor:buttonColor];
    _popView.titleLabel.text = @"Please Select";
    
    __block MIDPopView *popView = _popView;
    __block HPRTPageVC *pageVC = self;
    [_popView addButtonWithTitle:@"OK" handler:^(MIDPopViewButton *button) {
        
        [popView hideAnimation];
        [pageVC updateTitleAndParameter:[NSNumber numberWithInt:row]];
        [pageVC setupFootTable];
    }];
    
    [_popView show];
    
    MIDToolBox *tool = [[MIDToolBox alloc] init];
    NSArray *dataArray;
    
    NSArray *numberArray = @[@383,@935,@284,@936,@100,@100];
    if (row !=6 ) {
        
        dataArray = [tool generateNumberArrayWith:numberArray[row]];
    }else {
        
        dataArray = @[@[@"Left to right",@"Down to up",@"Right to left",@"Up to down"]];
    }

    
    MIDPickerKit *picker = [[MIDPickerKit alloc] initWithWidth:SCREEN_WIDTH*0.6 Height:SCREEN_HEIGHT*0.4*0.8 withDataSource:dataArray];
    [_popView.footView addSubview:picker];
}


- (void)setupDataSource {
    
    _alignmentArray = @[@"Left to right",@"Down to up",@"Right to left",@"Up to down"];
    _alignmentDic = @{@"Left to right":@"0",@"Down to up":@"1",@"Right to left":@"2",@"Up to down":@"3"};
    _detailTextArray = [[NSMutableArray alloc] initWithObjects:@"0",@"0",@"200",@"200",@"0",@"0",@"Left to right", nil];
    _parameterArray = [[NSMutableArray alloc] initWithObjects:@0,@0,@200,@200,@0,@0,@0, nil];
}


- (void)sendToPrinterAction
{
    
    int leftMargin  = [_parameterArray[0] intValue];
    int topMargin   = [_parameterArray[1] intValue];
    int pageWidth   = [_parameterArray[2] intValue];
    int pageHeight  = [_parameterArray[3] intValue];
    int xCoordinate = [_parameterArray[4] intValue];
    int yCoordinate = [_parameterArray[5] intValue];
    int printDirection = [_parameterArray[6] intValue];
    
    HPRTFunctionESC *esc = [[HPRTFunctionESC alloc] init];
    NSData *data = [esc escPrintPageWithHorizontal:leftMargin Vertical:topMargin Width:pageWidth Height:pageHeight XPosition:xCoordinate YPosition:yCoordinate Direction:printDirection];
    HPRTCommandESC *cmdESC = [[HPRTCommandESC alloc] init];
    NSData *textData = [cmdESC generateTextDataWithEncoding:_flatView.textView.text];
    [[HPRTDispatcher share] sendDataQueue:@[data,textData]];
    
    [self popSuccessView];
}

- (void)popSuccessView {
    
    UIColor *headColor = PRTCOLOR_GRAY;
    _popView = [[MIDPopView alloc] initWithWidth:SCREEN_WIDTH*0.6 Height:SCREEN_HEIGHT*0.3 splitPercentage:0.3 headColor:headColor buttonColor:nil];
    _popView.titleLabel.text = @"Send Success";
    _popView.footView.backgroundColor = PRTCOLOR_COULD;
    
    UILabel *label = [[UILabel alloc] initWithFrame:CGRectMake(0, 0, SCREEN_WIDTH*0.6, SCREEN_HEIGHT*0.15)];
    label.text = @"Data send success";
    label.textColor = [UIColor grayColor];
    label.textAlignment = NSTextAlignmentCenter;
    label.backgroundColor = PRTCOLOR_COULD;
    [_popView.footView addSubview:label];
    
    __block MIDPopView *popView = _popView;
    [_popView addButtonWithTitle:@"OK" handler:^(MIDPopViewButton *button) {
        
        [popView hideAnimation];
    }];
    
    [_popView show];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (void)viewWillAppear:(BOOL)animated {
    
    self.navigationController.navigationBar.barTintColor = PRTCOLOR_BLUE;
    self.navigationController.navigationBar.alpha = 1.0;
    [self.navigationController.navigationBar setTranslucent:NO];
    
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(notificationUserSelectCell:) name:@"NotificationUserSelectCell" object:nil];
}

- (void)viewWillDisappear:(BOOL)animated {
    
    [[NSNotificationCenter defaultCenter] removeObserver:self];
}

@end
