//
//  HPRTBitmap.h
//
//  Created by midmirror on 15/12/22.
//  Copyright © 2015年 midmirror. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>
#import "HPRTPublicDefine.h"

/**
 *  位图处理：生成黑白二值图片或者抖动后的视觉灰度图片
 */
@interface HPRTBitmap : NSObject{
    UIImage *m_image;
    NSData *starImageData;
    bool ditheringSupported;
}

singletonH(HPRTBitmap)

/**
 * Print binary bitmap (black white bitmap)
 * 打印黑白二值图像
 *
 *  @param sourceBitmap  sourceImage
 *
 *  @return a generated data to print
 */
- (NSData *)generateMonoBitmapDefault:(UIImage *)sourceBitmap;

/**
 *  Print Dither Bitmap
 *  打印经过抖动的视觉灰度图
 *
 *  @param sourceBitmap
 *
 *  @return a generated data to print
 */
- (NSData *)generateDitherBitmapDefault:(UIImage *)sourceBitmap;

- (NSData *)addPrintCode:(NSData *)data Width:(int)imageWidth Height:(int)imageHeight;

//- (UIImage *)generateMonoBimap:(UIImage *)image;
//- (UIImage *)generateBitmapWithMonochromeFilter:(UIImage *)image R:(float)r G:(float)g B:(float)b;
//- (id)initWithUIImage:(UIImage *)image :(int)maxWidth :(bool)dithering;
//- (NSData *)getImageDataForPrinting:(UIImage *)image;

@end
