//
//  MIDEffectLayer.h
//  MIDKit
//
//  Created by midmirror on 16/2/26.
//  Copyright © 2016年 midmirror. All rights reserved.
//

#import <QuartzCore/QuartzCore.h>
#import <UIKit/UIKit.h>

@interface MIDEffectLayer : NSObject

/**
 * 用法：
 * MIDEffectLayer *effect = [[MIDEffectLayer alloc] init];
 * CAGradientLayer *shimmerLayer = [effect generateShimmerLayer];
 * shimmerLayer.frame = _titleLabel.frame;
 * _titleLabel.layer.mask = shimmerLayer;
 *
 */
- (CAGradientLayer *)generateShimmerLayer;

/**
 *  用法:
 *  MIDEffectLayer *effect = [[MIDEffectLayer alloc] init];
 *  CALayer *pulseLayer = [effect generatePulseLayer:_headView];
 *  [_headView.layer insertSublayer:pulseLayer below:_phoneLogoView.layer];
 
 * 注册监听UIApplicationDidBecomeActiveNotification，当程序从后台返回前台时，重新调用。
 *
 */
- (CALayer *)generatePulseLayer:(UIView *)superView;

@end
