//
//  MIDPopView.h
//
//  Created by midmirror on 16/1/29.
//  Copyright © 2016年 midmirror. All rights reserved.
//

#import <UIKit/UIKit.h>

@class MIDPopViewButton;

typedef void(^MIDPopHandler)(MIDPopViewButton *button);

@interface MIDPopView : UIView

@property(strong,nonatomic,readwrite) UILabel *titleLabel;
@property(strong,nonatomic,readwrite) UIView *headView;
@property(strong,nonatomic,readwrite) UIView *footView;
@property(strong,nonatomic,readwrite) UIView *buttonView;
@property(strong,nonatomic,readwrite) NSMutableArray *buttonArray;

/**
 *  展示 PopView
 */
- (void)show;

/**
 *  初始化一个弹出视图
 *
 *  @param width       视图的宽度
 *  @param height      视图的高度
 *  @param percentage  视图头部所占的比例，0-1之间的小数，一般头部放置标题
 *  @param headcolor   是不头部的颜色
 *  @param buttonColor 按钮的颜色
 *
 *  @return 弹出视图
 */
- (id)initWithWidth:(float)width Height:(float)height splitPercentage:(float)percentage headColor:(UIColor *)headcolor buttonColor:(UIColor *)buttonColor;

/**
 *  为 PopView 弹出视图增加一个按钮
 *
 *  @param title   按钮的名字
 *  @param handler
 */
- (void)addButtonWithTitle:(NSString *)title handler:(MIDPopHandler)handler;
- (void)hideAnimation;

@end

@interface MIDPopViewButton : NSObject

/**
 *  按钮的标题
 */
@property (nonatomic, copy) NSString *title;

/**
 *  按钮的类型
 */
//@property (nonatomic) MIDPopViewButtonType type;

/**
 *  按钮的 Tag
 */
@property (nonatomic) NSUInteger tag;
@property (nonatomic, copy) MIDPopHandler action;

@end
