//
//  PRTTableView.h
//
//  Created by midmirror on 16/1/29.
//  Copyright © 2016年 midmirror. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "MIDPublicDefine.h"

typedef NS_ENUM(NSInteger,MIDTableMode) {
    
    MIDTableModeBluetooth = 0,
    MIDTableModeBitmap,
    MIDTableModeNormal,
    MIDTableModeTextAdaptive,
};

typedef NS_ENUM(NSInteger,MIDTableDataIndex) {
    
    Text = 0,
    DetailText,
    ContentView,
};

@interface MIDTableKit : UIView<UITableViewDataSource,UITableViewDelegate>

singletonH(MIDTableKit)

@property(strong,nonatomic,readwrite) UITableView *tableView;

/**
 *  表视图的数据源
 */
@property(strong,nonatomic,readwrite) NSArray *dataArray;

/**
 *  表视图的展示模式
 */
@property(nonatomic) MIDTableMode tableMode;

/**
 *  初始化一个表视图组件
 *
 *  @param width     视图的宽度
 *  @param height    视图的高度
 *  @param dataArray 视图的数据源，注意程序中如何构建一个合理的数组
 *  @param tableMode 展示模式
 *  @param checkMark 是否显示导向箭头
 *
 *  @return 表视图
 */
- (id)initWithWidth:(float)width Height:(float)height DataArray:(NSArray *)dataArray TableMode:(MIDTableMode)tableMode CheckMark:(BOOL)checkMark;

@end
